## ball 1.5.0+git20220524.d85d2dd

=== CMakeLists.txt ===
########################################################
#
# CMake configuration for BALL
# http://www.ball-project.org
#
########################################################

CMAKE_MINIMUM_REQUIRED(VERSION 3.1.0 FATAL_ERROR)

CMAKE_POLICY(SET CMP0042 OLD)
CMAKE_POLICY(SET CMP0043 NEW)
CMAKE_POLICY(SET CMP0048 NEW)

IF(POLICY CMP0071)
	CMAKE_POLICY(SET CMP0071 NEW)
ENDIF()


PROJECT("BALL" VERSION 1.5.0)


########################################################
# General build system settings
########################################################

# Use folders to group TARGTES using the folder target property in IDEs
SET(USE_FOLDERS TRUE)

# Automatically search lib64 folders
SET(FIND_LIBRARY_USE_LIB64_PATHS TRUE)

# Set default build type to Release
IF(NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE Release)
ENDIF()

# Add cmake directory from BALL source tree to CMAKE_MODULE_PATH
SET(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${PROJECT_SOURCE_DIR}/cmake")

# Add include directoy from BALL source tree
INCLUDE_DIRECTORIES("${PROJECT_SOURCE_DIR}/include")

# Add include directoy from build tree for configured files
INCLUDE_DIRECTORIES("${PROJECT_BINARY_DIR}/include")

# Handling user specified path to ball_contrib installation (-DBALL_CONTRIB_PATH)
# TODO: Get rid of BALL_CONTRIB_PATH when globally refactoring build system
SET(BALL_CONTRIB_PATH "" CACHE PATH "Path to the ball_contrib installation directory (optional)")
IF(BALL_CONTRIB_PATH)
	# Add include directoy from user specified BALL_CONTRIB_PATH
	INCLUDE_DIRECTORIES("${BALL_CONTRIB_PATH}/include")

	# Add ball contrib install directories to CMake search paths for find_XXX() functions
	SET(CMAKE_PREFIX_PATH  "${BALL_CONTRIB_PATH}" "${CMAKE_PREFIX_PATH}")

	# Required for CMake include and compile tests (seems to be required only on Windows)
	SET(CMAKE_REQUIRED_INCLUDES ${BALL_CONTRIB_PATH}/include ${CMAKE_REQUIRED_INCLUDES})
ENDIF()

# Include BALL specific CMake macros
INCLUDE(cmake/BALLMacros.cmake)

# BALL specific compiler and linker settings
SET(BALL_PROJECT_COMPILE_FLAGS "")
SET(BALL_PROJECT_COMPILE_DEFNS "")
INCLUDE(BALLCompilerSpecific)

# Determine BALL configuration
INCLUDE(BALLConfiguration)

INCLUDE(GNUInstallDirs)

# We do not have a Component-based installer in MacOS
IF(NOT APPLE)
	INCLUDE(BALLComponents)
ENDIF()

# License choice: LGPL or GPL build
SET(BALL_LICENSE "LGPL" CACHE STRING "BALL licensing model: LGPL (default) or GPL")

IF(${BALL_LICENSE} STREQUAL "LGPL")
	SET(BALL_LICENSE_LGPL TRUE)
	SET(BALL_LICENSE_GPL  FALSE)
ELSEIF(${BALL_LICENSE} STREQUAL "GPL")
	SET(BALL_LICENSE_LGPL FALSE)
	SET(BALL_LICENSE_GPL  TRUE)
ELSE()
	MESSAGE(FATAL_ERROR "BALL_LICENSE can either be 'LGPL' (default) or 'GPL'")
ENDIF()



########################################################
# Search and configure third party dependencies
########################################################

## Extra libraries we want to link into BALL
SET(BALL_DEP_LIBRARIES)
SET(VIEW_DEP_LIBRARIES)

## Flex and Bison
## This ugly hack is required as long as we cannot tell cmake to set an environment variable for bison...
IF (WIN32)
	FIND_PROGRAM(BISON_EXECUTABLE BALL-bison.bat DOC "path to the bison executable")
ENDIF()
FIND_PACKAGE(BISON)
IF (NOT BISON_FOUND)
	MESSAGE(FATAL_ERROR "Could not find bison parser generator!")
ENDIF()

IF (WIN32)
	SET(BALL_BISON_BAT ${BISON_EXECUTABLE})
	SET(BISON_EXECUTABLE "call")
ENDIF()

FIND_PACKAGE(FLEX)
IF (NOT FLEX_FOUND)
	MESSAGE(FATAL_ERROR "Could not find flex scanner generator!")
ENDIF()
## Figure out if the used flex version supports ...lex_destroy()
MESSAGE(STATUS "Checking for yylex_destroy support in flex")
STRING(REGEX REPLACE "^([0-9]+)\\.([0-9]+)\\.([0-9]+).*$" "\\1;\\2;\\3"
	FLEX_VERSION_NUMERIC ${FLEX_VERSION})
LIST(GET FLEX_VERSION_NUMERIC 2 FLEX_PATCH_LEVEL)
IF (FLEX_PATCH_LEVEL GREATER 8)
	MESSAGE(STATUS "Checking for yylex_destroy support in flex - found")
	SET(BALL_HAS_YYLEX_DESTROY TRUE)
ELSE()
	MESSAGE(STATUS "Checking for yylex_destroy support in flex - Not found")
	SET(BALL_HAS_YYLEX_DESTROY FALSE)
ENDIF()


## XDR related stuff
INCLUDE(BALLConfigXDR)

## Boost and Asio
INCLUDE(BALLConfigBoost)

INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
LIST(APPEND BALL_DEP_LIBRARIES ${Boost_LIBRARIES})



# OpenBabel availability: default false
SET(BALL_HAS_OPENBABEL FALSE)

IF(${BALL_LICENSE_GPL})

	# FFTW
	OPTION(USE_FFTWD "Use double precision FFTW if found" ON)
	OPTION(USE_FFTWF "Use single precision FFTW if found" ON)
	OPTION(USE_FFTWF "Use long double precision FFTW if found" ON)
	OPTION(USE_FFTW_THREADS "Try to find FFTW with thread support" OFF)

	FIND_PACKAGE(FFTW)
	IF(FFTW_FOUND)
		INCLUDE_DIRECTORIES(${FFTW_INCLUDE_DIR})
		INCLUDE(BALLConfigFFTW)
	ENDIF()

	#Set the default complex precision to float if the setting for this value
	#could not be determined earlier
	IF(NOT BALL_COMPLEX_PRECISION)
		SET(BALL_COMPLEX_PRECISION "float")
	ENDIF()


	# OpenBabel
	FIND_PACKAGE(OpenBabel2)
	IF(OPENBABEL2_FOUND)
		SET(BALL_HAS_OPENBABEL TRUE)
		INCLUDE_DIRECTORIES(${OPENBABEL2_INCLUDE_DIRS})
		LIST(APPEND BALL_DEP_LIBRARIES ${OPENBABEL2_LIBRARIES})
	ELSE()
		MESSAGE("Could not find a OpenBabel2 installation. Skipping OpenBabel dependencies.")
	ENDIF()

ENDIF()


## lpsolve
OPTION(USE_LPSOLVE "Compile with lpsolve support, if lpsolve can be found" ON)

FIND_PACKAGE(LPSolve)
IF (LPSOLVE_FOUND)
	SET(BALL_HAS_LPSOLVE TRUE)
	INCLUDE_DIRECTORIES(${LPSOLVE_INCLUDE_DIR})
ENDIF()

## libsvm
OPTION(USE_LIBSVM "Compile with libsvm support if libsvm can be found" ON)

IF(USE_LIBSVM)
	FIND_PACKAGE(libSVM)
	IF (LIBSVM_FOUND)
		SET(BALL_HAS_LIBSVM TRUE)
		INCLUDE_DIRECTORIES(${LIBSVM_INCLUDE_DIRS})
	ENDIF()
ENDIF()

## CUDA
SET(USE_CUDA OFF CACHE BOOL "Should CUDA support be enabled (version <= 2.1 currently supported)?")

IF(USE_CUDA)
	FIND_PACKAGE(CUDA REQUIRED)
ENDIF()

## TBB
SET(USE_TBB ON CACHE BOOL "Should Intel Threading Building Blocks support be enabled?")
SET(REQUIRE_TBB OFF CACHE BOOL "Should Intel Threading Building Blocks support be required?")

## RTFact would require tbb... so check if it is required
IF(REQUIRE_RTFACT)
	SET(REQUIRE_TBB ON)
ENDIF()

IF(USE_TBB)
	IF (REQUIRE_TBB)
		FIND_PACKAGE(TBB REQUIRED)
	ELSE()
		FIND_PACKAGE(TBB)
		IF (NOT TBB_FOUND)
			MESSAGE(STATUS "Intel Threading Building Blocks not found!")
		ENDIF()
	ENDIF()

	IF(${BALL_LICENSE_GPL} OR NOT ${TBB_VERSION_MAJOR} VERSION_LESS 2017)

		IF (TBB_FOUND)
			INCLUDE_DIRECTORIES(${TBB_INCLUDE_DIRS})
			BALL_COMBINE_LIBS(TBB_LIBRARIES "${TBB_LIBRARIES}" "${TBB_DEBUG_LIBRARIES}")
			LIST(REMOVE_DUPLICATES TBB_LIBRARIES)

			SET(BALL_HAS_TBB TRUE)
		ENDIF()

	ENDIF()

ENDIF()

## MPI
OPTION(USE_MPI "Should MPI support be enabled?" OFF)
OPTION(REQUIRE_MPI "Should MPI support be required?" OFF)

IF (USE_MPI)
	IF (NOT BALL_HAS_XDR)
		MESSAGE(STATUS "XDR has not been found, which is required for MPI support. Disabling MPI support.")
	ELSEIF (REQUIRE_MPI)
		FIND_PACKAGE(MPI REQUIRED)
	ELSE()
		FIND_PACKAGE(MPI)
	ENDIF()

	IF (MPI_FOUND)
		SET(BALL_PROJECT_COMPILE_FLAGS "${BALL_PROJECT_COMPILE_FLAGS} ${MPI_CXX_COMPILE_FLAGS}")
		INCLUDE_DIRECTORIES(${MPI_CXX_INCLUDE_PATH})

		SET(BALL_HAS_MPI TRUE)
	ENDIF()
ENDIF()

## VIEW related options/settings/libraries
SET(UPDATE_TRANSLATIONS OFF CACHE BOOL "If enabled, translations are update")
OPTION(BALL_HAS_VIEW "Compile BALL's VIEW library required for visualization and graphical user interfaces" ON)

## QT
OPTION(USE_QTWEBENGINE "Add support for QtWebEngine" ON)

# Enable automatic invocation of moc if required
SET(CMAKE_AUTOMOC ON)
SET(CMAKE_AUTOMOC_MOC_OPTIONS "-DBALL_DEPRECATED=") # Fix issues on some machines where moc would ignore classes with
                                                    # multiple attribute specifications via global macros

SET(QTDIR "" CACHE PATH "Path to the qt installation (optional)")
SET(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${QTDIR})

IF(QTDIR)
	INCLUDE_DIRECTORIES(BEFORE "${QTDIR}/include")
ENDIF()

SET(QT_MIN_VERSION 5.5)

FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} REQUIRED Core Network Xml)

LIST(APPEND BALL_DEP_LIBRARIES Qt5::Core
                               Qt5::Network
                               Qt5::Xml)
#LIST(APPEND BALL_PROJECT_COMPILE_DEFNS "-DQT_NO_KEYWORDS")

IF (BALL_HAS_VIEW)
	FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} REQUIRED OpenGL PrintSupport Test Widgets)
	FIND_PACKAGE(Qt5LinguistTools ${QT_MIN_VERSION})

	IF(NOT Qt5LinguistTools_FOUND)
		MESSAGE(WARNING "Qt5LinguistTools not found: BALLView translations cannot be created and compiled.")
	ENDIF()

	LIST(APPEND VIEW_DEP_LIBRARIES Qt5::OpenGL
	                               Qt5::PrintSupport
	                               Qt5::Test
	                               Qt5::Widgets)

	# WebEngine support
	IF(USE_QTWEBENGINE)
		FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} QUIET COMPONENTS WebEngine WebEngineWidgets WebChannel)

		SET(BALL_HAS_QTWEBENGINE TRUE)
		IF(NOT Qt5WebEngine_FOUND)
			MESSAGE(STATUS "QtWebEngine has not been found. Disabling WebEngine support.")
			SET(BALL_HAS_QTWEBENGINE FALSE)
		ENDIF()

		IF(NOT Qt5WebEngineWidgets_FOUND)
			MESSAGE(STATUS "QtWebEngineWidgets has not been found. Disabling WebEngine support.")
			SET(BALL_HAS_QTWEBENGINE FALSE)
		ENDIF()

		IF(NOT Qt5WebChannel_FOUND)
			MESSAGE(STATUS "QtWebChannel has not been found. Disabling WebEngine support.")
			SET(BALL_HAS_QTWEBENGINE FALSE)
		ENDIF()

		IF(BALL_HAS_QTWEBENGINE)
			LIST(APPEND VIEW_DEP_LIBRARIES Qt5::WebEngineWidgets Qt5::WebChannel)
		ENDIF()
	ENDIF()
ENDIF()

## On Windows, we might need to explicitly deploy openssl libraries for Qt
IF(WIN32)
	FIND_PATH(QT_SSLEAY_LIB NAME ssleay32.dll PATHS ${QT_BINARY_DIR} NO_DEFAULT_PATH)
	IF(QT_SSLEAY_LIB)
		LIST(APPEND QT_LIBRARIES ${QT_SSLEAY_LIB}/ssleay32.dll)
	ENDIF()

	FIND_PATH(QT_LIBEAY_LIB NAME libeay32.dll PATHS ${QT_BINARY_DIR} NO_DEFAULT_PATH)
	IF(QT_SSLEAY_LIB)
		LIST(APPEND QT_LIBRARIES ${QT_LIBEAY_LIB}/libeay32.dll)
	ENDIF()
ENDIF()

SET(EIGEN3_VERSION_OK "3.0.0")
FIND_PACKAGE(Eigen3 REQUIRED)
INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIR})

## VIEW dependent packages
IF (BALL_HAS_VIEW)

	## VIEW dependent options
	OPTION(USE_GLEW "Use the OpenGL Extension Wrangler library" ON)
	OPTION(USE_RTFACT "Enable RTfact support" ON)
	OPTION(REQUIRE_RTFACT "Require RTfact support" OFF)

	## OpenGL
	FIND_PACKAGE(OpenGL)
	IF (NOT OPENGL_FOUND OR NOT OPENGL_GLU_FOUND)
		MESSAGE(FATAL_ERROR "Could not find gl/glu!")
	ENDIF()
	INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})

	## GLEW
	IF (USE_GLEW)
		FIND_PACKAGE(GLEW)
		IF (GLEW_FOUND)
			SET(BALL_HAS_GLEW TRUE)
		ENDIF()
	ENDIF()

	## RTfact
	IF (USE_RTFACT)
		IF (REQUIRE_RTFACT)
			FIND_PACKAGE(RTfact REQUIRED)
		ELSE()
			FIND_PACKAGE(RTfact)
		ENDIF()

		IF (RTFACT_FOUND)
			## RTfact requires TBB
			IF (NOT CXX_COMPILER_ID STREQUAL "Intel")
				IF (NOT BALL_HAS_TBB)
					MESSAGE(FATAL_ERROR "RTfact support requires TBB!")
				ENDIF()
			ENDIF()

			SET(BALL_HAS_RTFACT TRUE)
			INCLUDE_DIRECTORIES(${RTFACT_INCLUDE_DIR})
		ENDIF()
	ENDIF()

ENDIF(BALL_HAS_VIEW)

## Python
OPTION(BALL_PYTHON_SUPPORT "Compile BALL's python interface (requires python development packages)" ON)

IF (BALL_PYTHON_SUPPORT)
	# make sure that we set the modules that come with contrib
	IF(BALL_CONTRIB_PATH)
		IF(WIN32)
			SET(ENV{PYTHONPATH} "$ENV{PYTHONPATH};${BALL_CONTRIB_PATH}/install/lib/python")
		ELSE()
			SET(ENV{PYTHONPATH} "$ENV{PYTHONPATH}:${BALL_CONTRIB_PATH}/install/lib/python")
		ENDIF()
		SET(BALL_PYTHONPATH $ENV{PYTHONPATH})
	ENDIF()
	FIND_PACKAGE(Python3 COMPONENTS Interpreter Development)

	IF (Python3_FOUND)
		SET(SIP_EXTRA_OPTIONS "-e")
		FIND_PACKAGE(SIP 4.9 REQUIRED)
		SET(BALL_SIP_VERSION ${SIP_VERSION})
		SET(BALL_SIP_VERSION_STR ${SIP_VERSION_STR})
		INCLUDE_DIRECTORIES(${Python3_INCLUDE_DIR})
		INCLUDE_DIRECTORIES(${SIP_INCLUDE_DIR})
	ELSE()
		SET(BALL_PYTHON_SUPPORT OFF)
		MESSAGE(STATUS "Disabling python support.")
	ENDIF()

ENDIF()


IF(APPLE)

=== test/CMakeLists.txt ===
### Build rules for BALL's class tests
PROJECT("BALL_tests")

ENABLE_TESTING()

OPTION(BALL_TEST_VERBOSE "Use verbose output for the tests" ON)

SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/TEST)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

## For now, disable optimization for the tests
IF (CXX_COMPILER_ID MATCHES "Intel|GXX")
	SET(CMAKE_CXX_FLAGS_RELEASE_SAVED ${CMAKE_CXX_FLAGS_RELEASE})
	SET(CMAKE_CXX_FLAGS_RELEASE "-O0")
ENDIF()

INCLUDE(cmake/BALLTestExecutables.cmake)
INCLUDE(cmake/VIEWTestExecutables.cmake)

## BASIC
ADD_CUSTOM_TARGET(BASIC_TESTS)
ADD_DEPENDENCIES(BASIC_TESTS ${BALL_BASIC_TESTS})

## MATHS
ADD_CUSTOM_TARGET(MATHS_TESTS)
ADD_DEPENDENCIES(MATHS_TESTS ${BALL_MATHS_TESTS})

## SYSTEM
ADD_CUSTOM_TARGET(SYSTEM_TESTS)
ADD_DEPENDENCIES(SYSTEM_TESTS ${BALL_SYSTEM_TESTS})

## TODO: all of them...

## Restore build flags
IF (CXX_COMPILER_ID MATCHES "Intel|GXX")
	SET(${CMAKE_CXX_FLAGS_RELEASE} ${CMAKE_CXX_FLAGS_RELEASE_SAVED})
ENDIF()

SET(BALLTEST_SUPPORT_LIBRARIES "")
IF (UNIX)
	LIST(APPEND BALLTEST_SUPPORT_LIBRARIES "pthread")
ENDIF ()

# Now, add all tests as targets
SET(ALL_TESTS "")
FOREACH(group ${BALL_TESTS})
	FOREACH(test ${${group}})
		ADD_EXECUTABLE(${test} ${test}.C)
		TARGET_LINK_LIBRARIES(${test} BALL ${BALLTEST_SUPPORT_LIBRARIES})
		SET_PROPERTY(TARGET ${test} PROPERTY FOLDER ${group})
		SET_TARGET_PROPERTIES(${test} PROPERTIES COMPILE_FLAGS "${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")
		IF (NOT BALL_TEST_VERBOSE)
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test})
		ELSE()
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test} "-v")
		ENDIF()
		LIST(APPEND ALL_TESTS ${test})
	ENDFOREACH()
ENDFOREACH()

# Set the timeout of some tests to 2h
# This is needed for the memcheck running on the CI server
# which takes _very_ long
SET_TESTS_PROPERTIES (
	ScoringFunction_test
	AssignBondOrderProcessor_test1
	AssignBondOrderProcessor_test2
	PROPERTIES TIMEOUT 7200
)

IF (BALL_HAS_VIEW)
	FOREACH(test ${VIEW_TESTS})
		ADD_EXECUTABLE(${test} ${test}.C)
		TARGET_LINK_LIBRARIES(${test} BALL VIEW ${BALLTEST_SUPPORT_LIBRARIES})
		SET_TARGET_PROPERTIES(${test} PROPERTIES COMPILE_FLAGS "${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")
		SET_PROPERTY(TARGET ${test} PROPERTY FOLDER BALL_VIEW_TESTS)
		IF (NOT BALL_TEST_VERBOSE)
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test})
		ELSE()
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test} "-v")
		ENDIF()
	ENDFOREACH()

	LIST(APPEND ALL_TESTS ${VIEW_TESTS})
ENDIF()

# Create a suitable target
ADD_CUSTOM_TARGET(build_tests)
ADD_DEPENDENCIES(build_tests ${ALL_TESTS})

=== source/BENCHMARKS/CMakeLists.txt ===
PROJECT("BALL_benchmarks")

SET(EXECUTABLES
	CompositeCreation_bench
	CompositeClone_bench
	DataStructures_bench
	KernelCreation_bench
	KernelClone_bench
	KernelIteration_bench
	FragmentDB_bench
	AmberFF_bench
	CharmmFF_bench
	PDB_bench
	PoissonBoltzmann_bench
	ContourSurface_bench
	MolmecSupport_bench
)

SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/BENCHMARKS)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

FOREACH(i ${EXECUTABLES})
	ADD_EXECUTABLE(${i} EXCLUDE_FROM_ALL ${i}.C)
	TARGET_LINK_LIBRARIES(${i} BALL)
ENDFOREACH()

SET(BENCH_DIR ${CMAKE_SOURCE_DIR}/source/BENCHMARKS)

ADD_CUSTOM_TARGET(BENCHMARKS
	COMMAND ${BENCH_DIR}/runbenchmarks ${EXECUTABLES}
	DEPENDS ${EXECUTABLES}
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/bin/BENCHMARKS
)

=== source/EXTENSIONS/BALLAXY/CMakeLists.txt ===
PROJECT(BALLAXY)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured to not build the VIEW components. Disabling the BALLaxy plugin.")
	RETURN()
ENDIF()

IF(NOT BALL_HAS_QTWEBENGINE)
	MESSAGE(STATUS "QtWebEngine support has not been enabled. Disabling the BALLaxy plugin")
	RETURN()
ENDIF()

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(UI_SOURCES_LIST
	${DIRECTORY}/BALLaxyInterfacePreferences.ui
)

SET(SOURCES_LIST
	${DIRECTORY}/BALLaxyPlugin.C
	${DIRECTORY}/BALLaxyInterface.C
	${DIRECTORY}/BALLaxyInterfacePreferences.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/BALLaxyPlugin.h
	${DIRECTORY}/BALLaxyInterface.h
	${DIRECTORY}/BALLaxyInterfacePreferences.h
)

QT5_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT5_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT5_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginBALLaxy SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginBALLaxy PROPERTIES
	PREFIX ""
)

IF(NOT APPLE)
	INSTALL(TARGETS pluginBALLaxy
		COMPONENT "${COMPONENT_PLUGINS}"
		RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
		LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	)

	IF(WIN32)
		IF(QT_DEPLOY_EXECUTABLE)
			INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${QT_DEPLOY_EXECUTABLE} \$\{CMAKE_INSTALL_PREFIX\}/${CMAKE_INSTALL_BINDIR}/pluginBALLaxy.dll)"
				COMPONENT "Unspecified")
		ENDIF()
	ENDIF()
ENDIF()

TARGET_LINK_LIBRARIES(pluginBALLaxy BALL VIEW)

=== source/EXTENSIONS/JUPYTER/CMakeLists.txt ===
PROJECT(Jupyter)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured to not build the VIEW components. Disabling the Jupyter plugin.")
	RETURN()
ENDIF()

IF(NOT BALL_HAS_QTWEBENGINE)
	MESSAGE(STATUS "QtWebEngine support has not been enabled. Disabling the Jupyter plugin.")
	RETURN()
ENDIF()

IF(NOT BALL_PYTHON_SUPPORT)
	MESSAGE(STATUS "Python support has not been enabled. Disabling the Jupyter plugin.")
	RETURN()
ENDIF()

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(UI_SOURCES_LIST
	${DIRECTORY}/jupyterPreferences.ui
	${DIRECTORY}/jupyterServerTab.ui
)

SET(SOURCES_LIST
	${DIRECTORY}/jupyterPlugin.C
	${DIRECTORY}/jupyterPreferences.C
	${DIRECTORY}/jupyterServer.C
	${DIRECTORY}/jupyterServerTab.C
	${DIRECTORY}/jupyterTab.C
	${DIRECTORY}/jupyterWidget.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/jupyterPlugin.h
	${DIRECTORY}/jupyterPreferences.h
	${DIRECTORY}/jupyterServer.h
	${DIRECTORY}/jupyterServerTab.h
	${DIRECTORY}/jupyterTab.h
	${DIRECTORY}/jupyterWidget.h
)

QT5_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT5_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT5_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginJupyter SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginJupyter PROPERTIES
	PREFIX ""
)

IF(NOT APPLE)
	INSTALL(TARGETS pluginJupyter
		COMPONENT "${COMPONENT_PLUGINS}"
		RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
		LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	)

	IF(WIN32)
		IF(QT_DEPLOY_EXECUTABLE)
			INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${QT_DEPLOY_EXECUTABLE} \$\{CMAKE_INSTALL_PREFIX\}/${CMAKE_INSTALL_BINDIR}/pluginJupyter.dll)"
				COMPONENT "Unspecified")
		ENDIF()
	ENDIF()
ENDIF()

TARGET_LINK_LIBRARIES(pluginJupyter BALL VIEW Qt5::WebEngineWidgets)

=== source/EXTENSIONS/PRESENTABALL/CMakeLists.txt ===
PROJECT(PresentaBALL)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured to not build the VIEW components. Disabling the PresentaBALL plugin.")
	RETURN()
ENDIF()

IF(NOT BALL_HAS_QTWEBENGINE)
	MESSAGE(STATUS "QtWebEngine support has not been enabled. Disabling the PresentaBALL plugin.")
	RETURN()
ENDIF()

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(UI_SOURCES_LIST
	${DIRECTORY}/PresentaBALLSettings.ui
)

SET(SOURCES_LIST
	${DIRECTORY}/PresentaBALLPlugin.C
	${DIRECTORY}/PresentaBALLSettings.C
	${DIRECTORY}/PresentaBALLView.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/PresentaBALLPlugin.h
	${DIRECTORY}/PresentaBALLSettings.h
	${DIRECTORY}/PresentaBALLView.h
)

QT5_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT5_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT5_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginPresentaBALL SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginPresentaBALL PROPERTIES
	PREFIX ""
)

IF(NOT APPLE)
	INSTALL(TARGETS pluginPresentaBALL
		COMPONENT "${COMPONENT_PLUGINS}"
		RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
		LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	)

	IF(WIN32)
		IF(QT_DEPLOY_EXECUTABLE)
			INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${QT_DEPLOY_EXECUTABLE} \$\{CMAKE_INSTALL_PREFIX\}/${CMAKE_INSTALL_BINDIR}/pluginPresentaBALL.dll)"
				COMPONENT "Unspecified")
		ENDIF()
	ENDIF()
ENDIF()

TARGET_LINK_LIBRARIES(pluginPresentaBALL BALL VIEW Qt5::WebEngineWidgets Qt5::WebChannel)

=== source/EXTENSIONS/SPACENAV/CMakeLists.txt ===
PROJECT(SPACENAVIGATOR)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured to not build the VIEW components. Disabling the SpaceNavigator plugin.")
	RETURN()
ENDIF()

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

FIND_PACKAGE(SpaceNavigator)

IF(NOT SPNAV_FOUND)
	MESSAGE(STATUS "Could not find SpaceNavigator libraries. Disabling the SpaceNavigator plugin")
	RETURN()
ENDIF()

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(SOURCES_LIST
	${DIRECTORY}/spaceNavigatorDriver.C
	${DIRECTORY}/spaceNavigatorPlugin.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/spaceNavigatorPlugin.h
)
#IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
#	LIST(APPEND RESOURCES_LIST ${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns)
#	SET(MACOSX_BUNDLE_ICON_FILE BALLView.icns)
#	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns
#			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
#ENDIF()


QT5_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT5_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT5_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})
INCLUDE_DIRECTORIES(${SPNAV_INCLUDE_DIRS})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginSpaceNavigator SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginSpaceNavigator PROPERTIES PREFIX "")

INSTALL(TARGETS pluginSpaceNavigator
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginSpaceNavigator BALL VIEW ${SPNAV_LIBRARIES} Qt5::Core)

=== source/PYTHON/EXTENSIONS/CMakeLists.txt ===
PROJECT(BALLPython)

IF(BALL_PYTHON_SUPPORT)
	INCLUDE(SIPMacros)

	REMOVE_DEFINITIONS(-pedantic)

	INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR})

	SET(SIP_EXTRA_OPTIONS "-e")

	FILE(GLOB BALL_SIP_DEPENDS "BALL/*.sip")
	FILE(GLOB VIEW_SIP_DEPENDS "VIEW/*.sip")

	SET(SIP_EXTRA_FILES_DEPEND ${BALL_SIP_DEPENDS} ${VIEW_SIP_DEPENDS})

	# Add the BALLCore python bindings
	SET(SIP_EXTRA_SOURCES 
		BALL/pyBALLSipHelper.C
		BALL/pyIndexList.C
		BALL/pyConstant.C
	)
        ADD_SIP_PYTHON_MODULE(BALLCore BALLCoremodule BALL/BALLCore.sip BALL Qt5::Core)
	
	IF(BALL_HAS_VIEW)
		SET(SIP_EXTRA_SOURCES
			VIEW/pyCompositeList.C
			VIEW/pyBALLSipHelper.C
			VIEW/pyColorRGBAVector.C
			VIEW/pyDatasetVector.C
		)
		# Add the VIEW python bindings
		SET(SIP_INCLUDES ${PROJECT_SOURCE_DIR})
                ADD_SIP_PYTHON_MODULE(VIEW VIEWmodule VIEW/VIEW.sip BALL VIEW Qt5::Widgets)
	ENDIF()

	# Install the BALL.py script
	IF(NOT WIN32)
		SET(BALL_PY_LOCATION ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
	ELSE()
		SET(BALL_PY_LOCATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR})

	ENDIF()

	ADD_CUSTOM_COMMAND(TARGET BALLCoremodule POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/BALL.py ${BALL_PY_LOCATION}
	)

	IF(NOT APPLE)
		INSTALL(TARGETS BALLCoremodule
			COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
			RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		)

		IF(BALL_HAS_VIEW)
			INSTALL(TARGETS VIEWmodule
				COMPONENT "${COMPONENT_PYTHON_BINDINGS_VIEW}"
				RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
				LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			)
		ENDIF()

		INSTALL(FILES ${PROJECT_SOURCE_DIR}/BALL.py
			COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
			DESTINATION "${BALL_PYTHON_INSTALL_DIRECTORY}"
		)

		IF (WIN32)
			#		INSTALL(FILES ${PYTHON_EXECUTABLE}
			#	COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
			#	DESTINATION "${CMAKE_INSTALL_BINDIR}"
			#)


			GET_FILENAME_COMPONENT(PYTHON_SITE_PACKAGES_DIR ${Python3_EXECUTABLE} PATH)
			SET(PYTHON_SITE_PACKAGES_DIR "${PYTHON_SITE_PACKAGES_DIR}/lib")

			INSTALL(DIRECTORY "${PYTHON_SITE_PACKAGES_DIR}"
				COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
				DESTINATION "${CMAKE_INSTALL_BINDIR}"
			)
		ENDIF ()
	ENDIF()

ENDIF()

=== debian/changelog ===
ball (1.5.0+git20220524.d85d2dd-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Update Breaks+Replaces
  * Build-Depends: libgl-dev, liblpsolve55-dev, libnsl-dev, libsvm-dev,
    libtbb-dev
  * Build-Depends: python3-sipbuild, sip-tools

  [ Bas Couwenberg ]
  * Don't use qtwebengine5-dev on mipsel, package to be removed.

  [ Yavor Doganov ]
  * Run wrap-and-sort -ast.
  * debian/control (Build-Depends): Add lost qttools5-dev (#1026815).
    Remove libtirpc-dev; not really needed.  Remove Python-related stuff
    and chrpath (not sufficient for the job at hand).
    (libbal1.5, libballview1.5): Mark as Multi-Arch: same.
    (libball1.5-dev): Likewise.
    (Depends): Tighten inter-package dependencies.  Add missing
    dependencies to -dev packages.
    (libball1.5-doc) <Suggests>: Replace libball1.5 with libbal1.5-dev.
    <Conflicts>: Remove; obsolete.
    (Rules-Requires-Root): Remove; redundant.
    (Standards-Version): Claim compliance with 4.7.2; no changes needed.
  * debian/rules (CXXFLAGS, LDFLAGS): Remove definitions.
    (FORCE_SOURCE_DATE): Export for a reproducible tutorial.pdf.
    (common_targets): New helper variable.
    (override_dh_auto_configure): Run dh_auto_configure; fixes cross
    building.  Pass -DBALL_PYTHON_SUPPORT=OFF.
    Pass -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON for a reproducible build.
    (override_dh_auto_build-arch, override_dh_auto_build-indep): Use
    dh_auto_build so that parallel building works.
    (override_dh_installdocs-indep): Fix broken symlink; this allows
    BALLView to load the demo and the tutorial (Closes: #1040385).
    (override_dh_auto_install-arch): Install libraries and .cmake files in
    the Multi-Arch location.  Don't invoke chrpath.  Install .so symlinks
    in the -dev packages; they are useless otherwise.
    (override_dh_auto_install-indep): Fix lintian W: national-encoding.
  * debian/patches/gcc-15.patch: New; fix FTBFS with GCC 15
    (Closes: #1114056).
  * debian/patches/lpsolve-link.patch: New; fix linking with lpsolve.
  * debian/patches/cmake-4.patch: New; fix FTBFS with CMake 4
    (Closes: #1112717).
  * debian/patches/reproducibility.patch: New; fix two reproducibility
    issues related to Doxygen-generated documentation.
  * debian/patches/spelling-errors.patch: New; self-explanatory.
  * debian/patches/2to3.patch: Make Last-Update DEP-compliant.
  * debian/patches/missing_GLEW: Likewise.
  * debian/libball1.5-dev.dirs: Delete; not needed.
  * debian/tests/simple-examples: New test; compile some of the examples
    and run them against all available PDB files.
  * debian/tests/control: New file.
  * debian/libball1.5-data.lintian-overrides: Fix context syntax.
  * debian/libballview1.5-dev.lintian-overrides: Delete; no longer needed.
  * debian/ballview.1: Rename as...
  * debian/BALLView.1: ...so that lintian doesn't complain.
  * debian/ballview.manpages: Adjust filename.
  * debian/ballview.desktop: Rename as...
  * debian/BALLView.desktop: ...to match the executable.  Add %F to the
    Exec key to fix a lintian warning.  Add Keywords key.  Rename
    GenericName to Comment to fix an AppStream error.
  * debian/ballview.install: Adjust accordingly.
  * debian/libball1.5-doc.examples: New file; install all C++ examples.
  * debian/upstream/metadata: Add Repository and Repository-Browse.
  * debian/watch: Upgrade to version 5.
  * debian/copyright: Replace GPL-2+ with LGPL-2.1+.  Add FreeBSD and
    Modified BSD licenses.  Update copyright years.

 -- Yavor Doganov <yavor@gnu.org>  Thu, 13 Nov 2025 15:18:57 +0100

ball (1.5.0+git20180813.37fc53c-11.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop sip dependency. (Closes: #1060741)

 -- Bastian Germann <bage@debian.org>  Tue, 19 Aug 2025 01:10:41 +0200

ball (1.5.0+git20180813.37fc53c-11) unstable; urgency=medium

  * Team Upload.
  * Add B-D on qttools5-dev (Closes: #1026815)

 -- Nilesh Patra <nilesh@debian.org>  Wed, 21 Dec 2022 21:16:23 +0530

ball (1.5.0+git20180813.37fc53c-10) unstable; urgency=medium

  [ Andreas Tille ]
  * Fix dh_installdocs
    Closes: #1001657
  * Seems autopkgtest-pkg-python is running automagically - just provide
    the proper module name
  * Remove Python3 package since it does not work properly with SIP and
    is not really needed to run ballview
    Leave python3 related Build-Depends - otherwise cmake will stumble
    upon missing dependencies

  [ Étienne Mollier ]
  * d/rules: set SIP_LIBRARIES cmake variable; trigger sip bindings build.
  * Add fix-findsip.patch: adjust cmake file to trigger build.
    This also fixes a minor ftbfs in bindings, likely due to move to gcc-11.
  * Add fix-python-bindings.patch: adjust PyString_ and PyInt_ bindings to
    match types in use in Python 3.

 -- Andreas Tille <tille@debian.org>  Sat, 18 Dec 2021 16:49:53 +0100

ball (1.5.0+git20180813.37fc53c-9) unstable; urgency=medium

  * Add versions to Breaks fields
  * Move some docs to /usr/share/doc
  * Lintian-override for non-user oriented text files
  * build depend on qtwebengine5-dev also on mips64el
    Closes: #995409

 -- Andreas Tille <tille@debian.org>  Mon, 13 Dec 2021 08:53:26 +0100

ball (1.5.0+git20180813.37fc53c-8) unstable; urgency=medium

  * Remove unneeded Build-Depends
    Closes: #982365

 -- Andreas Tille <tille@debian.org>  Sun, 12 Dec 2021 15:11:43 +0100

ball (1.5.0+git20180813.37fc53c-7) unstable; urgency=medium

  [ Nilesh Patra ]
  * Team upload.
  * Fix FTBFS with glibc (Closes: #994480)

  [ Andreas Tille ]
  * Remove outdated lintian-overrides
  * Add missing DEP3 header
  * Use 2to3 to convert Python2 script to Python3
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.



=== debian/control ===
Source: ball
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Andreas Tille <tille@debian.org>,
 Steffen Moeller <moeller@debian.org>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 bison,
 cmake,
 flex,
 libboost-dev,
 libboost-iostreams-dev,
 libboost-thread-dev,
 libeigen3-dev,
 libgl-dev,
 libglew-dev,
 liblpsolve55-dev,
 libnsl-dev,
 libqt5opengl5-dev,
 libsvm-dev,
 libtbb-dev,
 libx11-dev,
 qtbase5-dev,
 qttools5-dev,
 qtwebengine5-dev [amd64 arm64 armhf i386 mips64el],
 tidy,
Build-Depends-Indep:
 doxygen,
 ghostscript,
 graphviz,
 texlive-fonts-recommended,
 texlive-latex-base,
 texlive-latex-extra,
 texlive-latex-recommended,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/ball
Vcs-Git: https://salsa.debian.org/med-team/ball.git
Homepage: http://www.ball-project.org/

Package: libball1.5-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Biochemical Algorithms Library (data files)
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 It provides an extensive set of data structures as well as classes
 for Molecular Mechanics, advanced solvation methods, comparison and
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland
 University, Saarbruecken, Germany).
 .
 This package contains the data files (force field parameters, fragment
 data bases, etc) necessary for using BALL.

Package: libball1.5
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 libball1.5-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 It provides an extensive set of data structures as well as classes
 for Molecular Mechanics, advanced solvation methods, comparison and
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland
 University, Saarbruecken, Germany).
 .
 This package contains the view - independent parts of BALL (libBALL,
 data directories et al., except for libVIEW) and can be installed on
 machines without X11.

Package: libball1.5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libball1.5 (= ${binary:Version}),
 libboost-dev,
 qtbase5-dev,
 ${misc:Depends},
Suggests:
 libball1.5-doc,
Description: Header files for the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 It provides an extensive set of data structures as well as classes
 for Molecular Mechanics, advanced solvation methods, comparison and
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland
 University, Saarbruecken, Germany).
 .
 This package comprises the header files allowing to create
 one's own applications with the BALL library.

Package: libballview1.5
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 libball1.5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Biochemical Algorithms Library, VIEW framework
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 It provides an extensive set of data structures as well as classes
 for Molecular Mechanics, advanced solvation methods, comparison and
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland
 University, Saarbruecken, Germany).
 .
 This package contains the view parts of BALL (libVIEW). Those are
 required for molecular visualization and for running BALLView.

Package: libballview1.5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libball1.5-dev (= ${binary:Version}),
 libballview1.5 (= ${binary:Version}),
 libqt5opengl5-dev,
 qtwebengine5-dev [amd64 arm64 armhf i386 mips64el],
 ${misc:Depends},
Recommends:
 libball1.5-doc,
Description: Header files for the VIEW part of the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 This package comprises the header files allowing to create one's own
 applications with the VIEW framework of the BALL library.

Package: ballview
Architecture: any
Depends:
 libball1.5 (= ${binary:Version}),
 libballview1.5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: free molecular modeling and molecular graphics tool
 BALLView provides fast OpenGL-based visualization of molecular structures,
 molecular mechanics methods (minimization, MD simulation using the
 AMBER, CHARMM, and MMFF94 force fields), calculation and visualization
 of electrostatic properties (FDPB) and molecular editing features.
 .
 BALLView can be considered a graphical user interface on the basis of
 BALL (Biochemical Algorithms Library) with a focus on the most common
 demands of protein chemists and biophysicists in particular.  It is
 developed in the groups of Hans-Peter Lenhof (Saarland University,
 Saarbruecken, Germany) and Oliver Kohlbacher (University of Tuebingen,
 Germany). BALL is an application framework in C++ that has been
 specifically designed for rapid software development in Molecular
 Modeling and Computational Molecular Biology.  It provides an extensive
 set of data structures as well as classes for Molecular Mechanics,
 advanced solvation methods, comparison and analysis of protein
 structures, file import/export, and visualization.

Package: libball1.5-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 libjs-jquery,
 ${misc:Depends},
Suggests:
 libball1.5-dev,
Description: documentation for the BALL library
 BALL (Biochemical Algorithms Library) is an application framework
 in C++ that has been specifically designed for rapid software
 development in Molecular Modeling and Computational Molecular Biology.
 The package comprises an extensive manual on how to program molecular
 modelling programs with BALL.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile-gmake -*-
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

SOVERSION=1.5
BALL_INSTALL_PATH=build
#PYTHON_VERSION=$(shell py3versions -d)
#PYTHON_SITE_PATH=/lib/python3/dist-packages

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Needed for a reproducible tutorial.pdf.
export FORCE_SOURCE_DATE := 1

common_targets := BALL VIEW BALLView

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
# The plugins are not installed so there is no sense to build them.
# TODO: The -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON option is passed by
# default in dh compat 14, so remove it when upgrading.
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=./usr \
	  -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	  -DBALL_PATH=/usr \
	  -DBALL_DATA_PATH=/usr/share/BALL-$(SOVERSION)/data \
	  -DBALL_PYTHON_SUPPORT=OFF \
	  -DBALL_BUILD_BALLAXY=OFF \
	  -DUSE_PRESENTABALL_PLUGIN=OFF

#		    -DSIP_LIBRARIES=/usr/lib/python3/dist-packages \

# Set BALL_DATA_PATH so that test scripts find it
export BALL_DATA_PATH=$(CURDIR)/data
# Make sure HOME exists (for Directory_test)
export HOME=/tmp

# The testsuite issues several failures
# Run it, but ignore the return code for now.
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --no-parallel -- || true
endif

# Different tests are failing in different runs

#The following tests FAILED:
#         86 - Composite_test4 (Failed)
#         87 - Composite_test5 (Failed)
#Errors while running CTest

#The following tests FAILED:
#        112 - Fragment_test (Failed)
#        113 - Chain_test (Failed)
#Errors while running CTest


override_dh_auto_build-arch:
	## Fix upstream issue of missing UI files
#	uic-qt4 source/VIEW/DIALOGS/assignBondOrderConfigurationDialog.ui > include/BALL/VIEW/UIC/ui_assignBondOrderConfigurationDialog.h
#	uic-qt4 source/VIEW/DIALOGS/assignBondOrderResultsDialog.ui       > include/BALL/VIEW/UIC/ui_assignBondOrderResultsDialog.h
#	uic-qt4 source/VIEW/DIALOGS/atomOverview.ui                       > include/BALL/VIEW/UIC/ui_atomOverview.h
	## ...
	## Uhmmm, seems we need to do this for all UI files mentioned in
	##   source/VIEW/DIALOGS/sources.cmake
	## but I really hope some cmake expert might be able to find a clue
	## how to trigger cmake to do it as intended by upstream.
	## Somehow the code
	##   ADD_BALL_UIFILES("VIEW/DIALOGS" "${UI_LIST}")
	## needs to be called before the build code below can be started
	dh_auto_build -- $(common_targets) install
# Don't build the tests if they are not going to be run.
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_build -- build_tests
endif

override_dh_auto_build-indep:
	dh_auto_build -- $(common_targets) doc doc_tutorial install

override_dh_auto_clean:
	[ -d source ] && cd source ; \
	if [ -f Makefile ] ; \
	then  \
		make clean ; \
		cd PYTHON/EXTENSIONS; \
		make clean; \
		rm -rf ../lib/Linux*; \
		rm -rf ../doc/doxygen/latex/*; \
		rm -f $(CURDIR)/source/config.status 2>/dev/null; \
	fi
	rm -f data/BALLView/translations/BALLView.de_DE.qm
	rm -f data/BALLView/translations/BALLView.zh_TW.qm
	rm -f doc/TUTORIAL/*.aux
	rm -rf $(BALL_INSTALL_PATH)
	find . -name "*.o" | xargs -r rm
	find . -type l | xargs -r rm
	find doc/TUTORIAL/ -name "tutorial.*" | egrep -v ".(tex|bib)$$" |xargs -r rm
	rm -f include/BALL/BALL.doc
	# find . -name "*.doc" -delete
	# Remove self-create UI header file
	rm -f include/BALL/VIEW/UIC/ui_assignBondOrderConfigurationDialog.h \
	      include/BALL/VIEW/UIC/ui_assignBondOrderResultsDialog.h \
	      include/BALL/VIEW/UIC/ui_atomOverview.h


override_dh_auto_install-arch:
	mkdir -p debian/libball$(SOVERSION)/usr/lib/$(DEB_HOST_MULTIARCH) \
		debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION) \
		debian/libballview$(SOVERSION)/usr/lib/$(DEB_HOST_MULTIARCH) \
                debian/ballview/usr/lib/ballview/

	mkdir -p debian/ballview/usr/share/BALL-$(SOVERSION)/data/graphics

	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/BALLView/*	debian/ballview/usr/share/doc/ballview/
	cp    $(BALL_INSTALL_PATH)/usr/bin/BALLView		debian/ballview/usr/lib/ballview/
	cp -a debian/bin/*					debian/ballview/usr/bin

	find $(BALL_INSTALL_PATH)/usr/lib/ -name libBALL*.so.* | xargs -r cp --target-directory debian/libball$(SOVERSION)/usr/lib/$(DEB_HOST_MULTIARCH)
	find $(BALL_INSTALL_PATH)/usr/lib/ -name libVIEW*.so.* | xargs -r cp --target-directory debian/libballview$(SOVERSION)/usr/lib/$(DEB_HOST_MULTIARCH)

	# debian needs the logo in the ballview - package, not in the libball
	cp $(BALL_INSTALL_PATH)/usr/share/BALL/graphics/ballview*.xpm debian/ballview/usr/share/pixmaps/

#	cp -r $(BALL_INSTALL_PATH)/usr/share/doc/BALL/EXAMPLES/PYTHON	debian/python3-ball/usr/share/BALL-$(SOVERSION)
#	cp -a source/PYTHON/EXTENSIONS/*       debian/python3-ball/usr/$(PYTHON_SITE_PATH)
#	cp $(BALL_INSTALL_PATH)/usr/lib/BALLCore.so   debian/python-ball/usr/$(PYTHON_SITE_PATH)

	# -dev packages are arch dependent
	mkdir -p debian/libball$(SOVERSION)-dev/usr/lib/$(DEB_HOST_MULTIARCH) \
		debian/libballview$(SOVERSION)-dev/usr/include/BALL \
		debian/libballview$(SOVERSION)-dev/usr/lib/$(DEB_HOST_MULTIARCH) \
		debian/libball$(SOVERSION)-dev/usr/include
	# move the cmake configuration files to their final location
	cp -R $(BALL_INSTALL_PATH)/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/ debian/libball$(SOVERSION)-dev/usr/lib/$(DEB_HOST_MULTIARCH)

	cp -r $(BALL_INSTALL_PATH)/usr/include/BALL       debian/libball$(SOVERSION)-dev/usr/include
	cp -r $(BALL_INSTALL_PATH)/usr/include/BALL/VIEW  debian/libballview$(SOVERSION)-dev/usr/include/BALL
	cp -P $(BALL_INSTALL_PATH)/usr/lib/$(DEB_HOST_MULTIARCH)/libBALL.so debian/libball$(SOVERSION)-dev/usr/lib/$(DEB_HOST_MULTIARCH)
	cp -P $(BALL_INSTALL_PATH)/usr/lib/$(DEB_HOST_MULTIARCH)/libVIEW.so debian/libballview$(SOVERSION)-dev/usr/lib/$(DEB_HOST_MULTIARCH)

	# get rid of the VIEW includes in libball-dev
	rm -rf debian/libball$(SOVERSION)-dev/usr/include/BALL/VIEW

override_dh_auto_install-indep:
	mkdir -p debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/html \
		debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc \
		debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/html/BALL

	cp    $(BALL_INSTALL_PATH)/usr/share/doc/BALL/TUTORIAL/tutorial.pdf	debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/
#	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/classes			debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc
#	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/internal			debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc
	# we need the BALLView documentation in the data path as well... sorry for that
	cp -r $(BALL_INSTALL_PATH)/usr/share/doc/BALL/EXAMPLES/PYTHON/BALLView	debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc
	cp -r $(BALL_INSTALL_PATH)/usr/share/doc/BALL/html/*			debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/html/BALL

	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/*    debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)

# Fix lintian W: national-encoding.
	iconv -f ISO-8859-1 -t UTF-8 < data/structures/test.btf \
	  > debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/structures/test.btf
	iconv -f ISO-8859-1 -t UTF-8 < data/gui-test/tutorial.btf \
	  > debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/gui-test/tutorial.btf
	iconv -f ISO-8859-1 -t UTF-8 < data/gui-test/selection.btf \
	  > debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/gui-test/selection.btf

override_dh_installdocs-indep:
	dh_installdocs -i
	find debian/*/usr/share -type d -empty -delete
	find debian/*/usr/share -name jquery.js -delete
	find debian/*/usr/share -name license.txt -delete
	mv debian/libball1.5-data/usr/share/BALL-1.5/BALLView/html debian/libball1.5-data/usr/share/doc/libball1.5-data/BALLView

=== debian/tests/control ===
Tests:
 simple-examples,
Restrictions:
 allow-stderr,
Depends:
 build-essential,
 pkgconf,
 @,

=== debian/watch ===
Version: 5

Source: https://github.com/BALL-Project/ball.git
Matching-Pattern: HEAD
Mode: git
Git-Pretty: 1.5.0+git%cd.%h
# Issue asking for release tags:
#   https://github.com/BALL-Project/ball/issues/655
# once this is fixed the old watch file can be brought into effect again:
#
# opts="uversionmangle=s/_/./g;s/-BETA/~beta/" \
#  https://github.com/BALL-Project/ball/releases .*/V?(\d[-\d._BETA]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
